/*
 * File:   compositions.c
 * Author: KELM
 *
 * Created on December 28, 2021, 11:20 AM
 */



#include "compositions.h"
#include "mcc_generated_files/pin_manager.h"
#include "mcc_generated_files/tmr0.h"
#include <stdio.h>
uint16_t tempo;

static void Sound_Play(uint16_t frequencyInHertz, uint16_t toneDuration)
{
  uint32_t period_us = (uint32_t)(1000000.0/frequencyInHertz+0.5)/2;
  uint32_t loop_num = (uint32_t)((((float)toneDuration*1000.0)/period_us+0.5));
  for(uint32_t i=0; i<loop_num; i++)
  {
    BUZZ_Toggle();
    TMR0_Reload();
    TMR0_StartTimer();
    while(TMR0_ReadTimer()<period_us);
    TMR0_StopTimer();
  }
}

static void spacedNote(uint16_t frequencyInHertz, uint8_t noteLength)
{
  uint16_t delayTime = (uint16_t) ((1000.0/tempo) * (60.0/4.0) * noteLength + 0.5);
  Sound_Play(frequencyInHertz,delayTime - 50);
  __delay_ms(50);
}

static void note(uint16_t frequencyInHertz, uint8_t noteLength)
{
  uint16_t delayTime = (uint16_t)((1000.0/tempo) * (60.0/4.0) * noteLength + 0.5);
  Sound_Play(frequencyInHertz, delayTime);
}

static void rest(uint16_t restLength)
{
  uint16_t delayTime = (uint16_t)((1000/tempo) * (60/4) * restLength + 0.5);
  for(uint16_t i=0; i<delayTime; i++)
    __delay_ms(1);
}

void furElise(){
  tempo = 90;
  //Measure 1
  note(NOTE_E6, EIGHTHNOTE);
  note(NOTE_DS6, EIGHTHNOTE);

  //Measure 2
  note(NOTE_E6, EIGHTHNOTE);
  note(NOTE_DS6, EIGHTHNOTE);
  note(NOTE_E6, EIGHTHNOTE);
  note(NOTE_B5, EIGHTHNOTE);
  note(NOTE_D6, EIGHTHNOTE);
  note(NOTE_C6, EIGHTHNOTE);

  //Measure 3
  note(NOTE_A3, EIGHTHNOTE);
  note(NOTE_E4, EIGHTHNOTE);
  note(NOTE_A4, EIGHTHNOTE);
  note(NOTE_C5, EIGHTHNOTE);
  note(NOTE_E5, EIGHTHNOTE);
  note(NOTE_A5, EIGHTHNOTE);

  //Measure 4
  note(NOTE_E3, EIGHTHNOTE);
  note(NOTE_E4, EIGHTHNOTE);
  note(NOTE_GS4, EIGHTHNOTE);
  note(NOTE_E5, EIGHTHNOTE);
  note(NOTE_GS5, EIGHTHNOTE);
  note(NOTE_B5, EIGHTHNOTE);

  //Measure 5
  note(NOTE_A3, EIGHTHNOTE);
  note(NOTE_E4, EIGHTHNOTE);
  note(NOTE_A4, EIGHTHNOTE);
  note(NOTE_E5, EIGHTHNOTE);
  note(NOTE_E6, EIGHTHNOTE);
  note(NOTE_DS6, EIGHTHNOTE);

  //Measure 6
  note(NOTE_E6, EIGHTHNOTE);
  note(NOTE_DS6, EIGHTHNOTE);
  note(NOTE_E6, EIGHTHNOTE);
  note(NOTE_B5, EIGHTHNOTE);
  note(NOTE_D6, EIGHTHNOTE);
  note(NOTE_C6, EIGHTHNOTE);

  //Measure 7
  note(NOTE_A3, EIGHTHNOTE);
  note(NOTE_E4, EIGHTHNOTE);
  note(NOTE_A4, EIGHTHNOTE);
  note(NOTE_C5, EIGHTHNOTE);
  note(NOTE_E5, EIGHTHNOTE);
  note(NOTE_A5, EIGHTHNOTE);

  //Measure 8
  note(NOTE_E3, EIGHTHNOTE);
  note(NOTE_E4, EIGHTHNOTE);
  note(NOTE_GS4, EIGHTHNOTE);
  note(NOTE_E5, EIGHTHNOTE);
  note(NOTE_GS5, EIGHTHNOTE);
  note(NOTE_B5, EIGHTHNOTE);

  //Measure 9
  note(NOTE_A3, EIGHTHNOTE);
  note(NOTE_E4, EIGHTHNOTE);
  note(NOTE_A4, EIGHTHNOTE);
  note(NOTE_E5, EIGHTHNOTE);
  note(NOTE_C6, EIGHTHNOTE);
  note(NOTE_D6, EIGHTHNOTE);

  //Measure 10
  note(NOTE_C4, EIGHTHNOTE);
  note(NOTE_G4, EIGHTHNOTE);
  note(NOTE_C5, EIGHTHNOTE);
  note(NOTE_G5, EIGHTHNOTE);
  note(NOTE_F6, EIGHTHNOTE);
  note(NOTE_E6, EIGHTHNOTE);

  //Measure 11
  note(NOTE_G3, EIGHTHNOTE);
  note(NOTE_G4, EIGHTHNOTE);
  note(NOTE_B4, EIGHTHNOTE);
  note(NOTE_F5, EIGHTHNOTE);
  note(NOTE_E6, EIGHTHNOTE);
  note(NOTE_D6, EIGHTHNOTE);

  //Measure 12
  note(NOTE_A3, EIGHTHNOTE);
  note(NOTE_E4, EIGHTHNOTE);
  note(NOTE_A4, EIGHTHNOTE);
  note(NOTE_E5, EIGHTHNOTE);
  note(NOTE_D6, EIGHTHNOTE);
  note(NOTE_C6, EIGHTHNOTE);

  //Measure 13
  note(NOTE_E3, EIGHTHNOTE);
  note(NOTE_E4, EIGHTHNOTE);
  note(NOTE_A5, EIGHTHNOTE);
  rest(EIGHTHNOTE);
}

void jingleBells(){
  tempo = 180;
  //Measure 1
  note(NOTE_B4, QUARTERNOTE);
  note(NOTE_B4, QUARTERNOTE);
  note(NOTE_B4, HALFNOTE);
  
  //Measure 2
  note(NOTE_B4, QUARTERNOTE);
  note(NOTE_B4, QUARTERNOTE);
  note(NOTE_B4, HALFNOTE);

  //Measure 3
  note(NOTE_B4, QUARTERNOTE);
  note(NOTE_D4, QUARTERNOTE);
  note(NOTE_G4, QUARTERNOTE);
  note(NOTE_G4, EIGHTHNOTE);
  note(NOTE_A4, EIGHTHNOTE);
  note(NOTE_B4, WHOLENOTE);

  //Measure 4
  note(NOTE_C4, QUARTERNOTE);
  note(NOTE_C4, QUARTERNOTE);
  note(NOTE_C4, QUARTERNOTE);
  note(NOTE_C4, EIGHTHNOTE);
  note(NOTE_C4, EIGHTHNOTE);
  note(NOTE_C4, QUARTERNOTE);
  note(NOTE_B4, QUARTERNOTE);
  note(NOTE_B4, QUARTERNOTE);
  note(NOTE_B4, EIGHTHNOTE);
  note(NOTE_B4, EIGHTHNOTE);
  
  //Measure 5
  note(NOTE_B4, QUARTERNOTE);
  note(NOTE_A4, QUARTERNOTE);
  note(NOTE_A4, QUARTERNOTE);
  note(NOTE_B4, QUARTERNOTE);
  
  //Measure 6
  note(NOTE_A4, HALFNOTE);
  note(NOTE_D4, HALFNOTE);
}

void imperialMarch(){
  tempo = 70;
  //Measure 1
  note(NOTE_A4, QUARTERNOTE);
  note(NOTE_A4, QUARTERNOTE);
  note(NOTE_A4, QUARTERNOTE);
  note(NOTE_F4, EIGHTHNOTE);
  note(NOTE_F4, SIXTEENTHNOTE);
  note(NOTE_C5, SIXTEENTHNOTE);

  //Measure 2
  note(NOTE_A4, QUARTERNOTE);
  note(NOTE_F4, EIGHTHNOTE);
  note(NOTE_F4, SIXTEENTHNOTE);
  note(NOTE_C5, SIXTEENTHNOTE);
  note(NOTE_A4, HALFNOTE);
  
  //Measure 3
  note(NOTE_E5, QUARTERNOTE);
  note(NOTE_E5, QUARTERNOTE);
  note(NOTE_E5, QUARTERNOTE);
  note(NOTE_F5, EIGHTHNOTE);
  note(NOTE_F5, SIXTEENTHNOTE);
  note(NOTE_C5, SIXTEENTHNOTE);
  
  //Measure 4
  note(NOTE_GS4, QUARTERNOTE);
  note(NOTE_F4, EIGHTHNOTE);
  note(NOTE_F4, SIXTEENTHNOTE);
  note(NOTE_CS4, SIXTEENTHNOTE);
  note(NOTE_A4, HALFNOTE);

  //Measure 5
  note(NOTE_A5, QUARTERNOTE);
  note(NOTE_A4, EIGHTHNOTE);
  note(NOTE_A4, SIXTEENTHNOTE);
  note(NOTE_A4, SIXTEENTHNOTE);
  note(NOTE_A5, QUARTERNOTE);
  note(NOTE_GS5, EIGHTHNOTE);
  note(NOTE_G5, EIGHTHNOTE);

  //Measure 6
  note(NOTE_FS5, SIXTEENTHNOTE);
  note(NOTE_F5, SIXTEENTHNOTE);
  note(NOTE_FS5, EIGHTHNOTE);
  __delay_ms(150);
  note(NOTE_AS4, EIGHTHNOTE);
  note(NOTE_DS5, QUARTERNOTE);
  note(NOTE_D5, EIGHTHNOTE);
  note(NOTE_CS5, EIGHTHNOTE);

  note(NOTE_C5, SIXTEENTHNOTE);
  note(NOTE_B4, SIXTEENTHNOTE);
  note(NOTE_C5, EIGHTHNOTE);
  __delay_ms(150);
  
  note(NOTE_F4, EIGHTHNOTE);
  note(NOTE_GS4, QUARTERNOTE);
  note(NOTE_F4, EIGHTHNOTE);
  note(NOTE_F4, SIXTEENTHNOTE);
  note(NOTE_A4, SIXTEENTHNOTE);

  note(NOTE_C5, QUARTERNOTE);
  note(NOTE_A4, EIGHTHNOTE);
  note(NOTE_A4, SIXTEENTHNOTE);
  note(NOTE_C5, SIXTEENTHNOTE);
  note(NOTE_E5, HALFNOTE);
  
  note(NOTE_A5, QUARTERNOTE);
  note(NOTE_A4, EIGHTHNOTE);
  note(NOTE_A4, SIXTEENTHNOTE);
  note(NOTE_A4, SIXTEENTHNOTE);
  note(NOTE_A5, QUARTERNOTE);
  note(NOTE_GS5, EIGHTHNOTE);
  note(NOTE_G5, EIGHTHNOTE);
  
  note(NOTE_FS5, SIXTEENTHNOTE);
  note(NOTE_F5, SIXTEENTHNOTE);
  note(NOTE_FS5, EIGHTHNOTE);
  __delay_ms(150);
  note(NOTE_AS4, EIGHTHNOTE);
  note(NOTE_DS5, QUARTERNOTE);
  note(NOTE_D5, EIGHTHNOTE);
  note(NOTE_CS5, EIGHTHNOTE);

  note(NOTE_C5, SIXTEENTHNOTE);
  note(NOTE_B4, SIXTEENTHNOTE);
  note(NOTE_C5, EIGHTHNOTE);
  __delay_ms(150);
  note(NOTE_F4, EIGHTHNOTE);
  note(NOTE_GS4, QUARTERNOTE);
  note(NOTE_F4, EIGHTHNOTE);
  note(NOTE_F4, SIXTEENTHNOTE);
  note(NOTE_A4, SIXTEENTHNOTE);

  note(NOTE_C5, QUARTERNOTE);
  note(NOTE_A4, EIGHTHNOTE);
  note(NOTE_A4, SIXTEENTHNOTE);
  note(NOTE_C5, SIXTEENTHNOTE);
  note(NOTE_E5, HALFNOTE);

}